\BMP2XPL.xpl	27-Feb-2011
\Converts ten 48x44 256-color images in a .BMP file into a 32-bit XPL constant
\ array. Also converts a vacuum tube image and sets up a Palette array.
\Compile with 32-bit XPL0 (xpx.bat)

include	c:\cxpl\codes;		\intrinsic code definitions

int	ImageWidth, ImageHeight;\dimensions of input .bmp image
char	Palette(3*256),
	Data(1024*768);		\enough to hold entire image, one pixel per byte



proc	WriteDigits;
int	H;
int	Dig, X0, Y0;


	proc	WriteTube;	\Write digit image data as a constant array
	int	I, X, Y, N;
	begin
	Text(3, "Tube"); Text(3, ":= [67+150<<8,
");					\sprite width, height packed in 16 bits
	I:= 0;
	for Y:= 44*2, 44*2+150-1 do
		begin
		for X:= 1, 68-1 do
			begin
			N:= N>>8;
			N:= N ! Data(X+Y*ImageWidth)<<24;
			if (I&3) = 0 then ChOut(3, ^$);
			if (I&3) = 3 then [HexOut(3, N); ChOut(3, ^,)];
			if (I&$1F) = $1F then CrLf(3);
			I:= I+1;
			end;
		end;
	Text(3, "0];

");
	end;	\WriteTube



	proc	WriteDigit;	\Write digit image data as a constant array
	int	I, X, Y, N;
	begin
	Text(3, "Digit("); IntOut(3, Dig); Text(3, "):= [48+44<<8,
");					\sprite width, height packed in 16 bits
	I:= 0;
	for Y:= Y0, Y0+44-1 do
		begin
		for X:= X0, X0+48-1 do
			begin
			N:= N>>8;
			N:= N ! Data(X+Y*ImageWidth)<<24;
			if (I&3) = 0 then ChOut(3, ^$);
			if (I&3) = 3 then [HexOut(3, N); ChOut(3, ^,)];
			if (I&$1F) = $1F then CrLf(3);
			I:= I+1;
			end;
		end;
	Text(3, "];

");
	end;	\WriteDigit



	proc	WritePalette;
	int	I, N;
	begin
	Text(3, "Palette:= [
");
	for I:= 0, 256*3-1 do
		begin
		N:= N>>8;
		N:= N ! Palette(I)<<24;
		if (I&3) = 0 then ChOut(3, ^$);
		if (I&3) = 3 then [HexOut(3, N); ChOut(3, ^,)];
		if (I&$1F) = $1F then CrLf(3);
		end;

	Text(3, "];

");
	end;	\WritePalette


begin	\WriteDigits
H:= FOpen("NixieClk.inc", 1);		\open file for output and get its handle
FSet(H, ^O);				\set device 3 to output to this handle
OpenO(3);				\initialize output for device 3

WritePalette;

for Dig:= 0, 9 do			\write 10 digit images
	begin
	Y0:= Dig/5 * 44;
	X0:= rem(0) * 48;
	WriteDigit;
	end;

WriteTube;

Close(3);
FClose(H);				\release file handle
end;	\WriteDigits



proc	LoadBmp(Name);	\Load a 256-color .BMP file into Palette and Data arrays
char	Name;				\file name
int	H, I, J, T, X, Y;		\handle, index, trash, and coordinates
int	R, G, B;
begin
H:= FOpen(Name, 0);			\open file and get its handle
FSet(H, ^I);				\set device 3 to input from this handle
OpenI(3);				\initialize input from device 3
for I:= 0, 17 do T:= ChIn(3);		\skip unused header info
ImageWidth:= ChIn(3) + ChIn(3)<<8;	\18
ImageWidth:= ImageWidth+3 & $FFFC;	\padded to a 4-byte boundary
T:= ChIn(3);   T:= ChIn(3);		\20, skip unused high bytes of Width
ImageHeight:= ChIn(3) + ChIn(3)<<8;	\22
for I:= 24, 53 do T:= ChIn(3);		\skip rest of header

\Read in the color table
J:= 0;
for I:= 0, 256*4-1 do
	begin
	B:= ChIn(3);			\.BMP files are in backwards (BGR) order
	G:= ChIn(3);
	R:= ChIn(3);
	T:= ChIn(3);

	Palette(J):= R>>2;		\rescale 8-bit values for the 6-bit H/W
	J:= J+1;
	Palette(J):= G>>2;
	J:= J+1;
	Palette(J):= B>>2;
	J:= J+1;

	I:= I+3;
	end;

for Y:= -(ImageHeight-1), 0 do		\load Data array
    for X:= 0, ImageWidth-1 do		\(.BMP files are upside down!)
	Data(X-Y*ImageWidth):= ChIn(3);
FClose(H);				\release handle
end;	\LoadBmp



begin	\Main
LoadBmp("NixieClk.BMP");
IntOut(0, ImageWidth); ChOut(0,^,); IntOut(0, ImageHeight); CrLf(0);
WriteDigits;
end;	\Main
